# all files / ol/format/ xsd.js

100% Statements 50/50
91.67% Branches 11/12
100% Functions 14/14
100% Lines 50/50

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    1681×

    1×
    1×

    1×

    1×
    19×
    19×

    1×
    64×
    64×
    23×

    41×

    1×
    15×
    15×
    15×

    1×
    244×
    244×

    1×

    280×
    280×
    264×

    16×

    1×
    814×
    814×

    1×
    891×
    891×
    882×

    9×

    1×
    827×

    1×
    4×

    1×
    1×

    1×
    14×
    14×

    14×

    1×
    28×
    28×

    1×
    4×
    4×

    1×
    449×

     goog.provide('ol.format.XSD');

    goog.require('ol.xml');
    goog.require('ol.string');

    /**
     * @const
     * @type {string}
     */
    ol.format.XSD.NAMESPACE_URI = 'http://www.w3.org/2001/XMLSchema';

    /**
     * @param {Node} node Node.
     * @return {boolean|undefined} Boolean.
     */
    ol.format.XSD.readBoolean = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      return ol.format.XSD.readBooleanString(s);
    };

    /**
     * @param {string} string String.
     * @return {boolean|undefined} Boolean.
     */
    ol.format.XSD.readBooleanString = function(string) {
      var m = /^\s*(true|1)|(false|0)\s*$/.exec(string);
      if (m) {
        return m[1] !== undefined || false;
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @return {number|undefined} DateTime in seconds.
     */
    ol.format.XSD.readDateTime = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      var dateTime = Date.parse(s);
      return isNaN(dateTime) ? undefined : dateTime / 1000;
    };

    /**
     * @param {Node} node Node.
     * @return {number|undefined} Decimal.
     */
    ol.format.XSD.readDecimal = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      return ol.format.XSD.readDecimalString(s);
    };

    /**
     * @param {string} string String.
     * @return {number|undefined} Decimal.
     */
    ol.format.XSD.readDecimalString = function(string) {
      // FIXME check spec
      var m = /^\s*([+\-]?\d*\.?\d+(?:e[+\-]?\d+)?)\s*$/i.exec(string);
      if (m) {
        return parseFloat(m[1]);
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @return {number|undefined} Non negative integer.
     */
    ol.format.XSD.readNonNegativeInteger = function(node) {
      var s = ol.xml.getAllTextContent(node, false);
      return ol.format.XSD.readNonNegativeIntegerString(s);
    };

    /**
     * @param {string} string String.
     * @return {number|undefined} Non negative integer.
     */
    ol.format.XSD.readNonNegativeIntegerString = function(string) {
      var m = /^\s*(\d+)\s*$/.exec(string);
      if (m) {
        return parseInt(m[1], 10);
      } else {
        return undefined;
      }
    };

    /**
     * @param {Node} node Node.
     * @return {string|undefined} String.
     */
    ol.format.XSD.readString = function(node) {
      return ol.xml.getAllTextContent(node, false).trim();
    };

    /**
     * @param {Node} node Node to append a TextNode with the boolean to.
     * @param {boolean} bool Boolean.
     */
    ol.format.XSD.writeBooleanTextNode = function(node, bool) {
      ol.format.XSD.writeStringTextNode(node, (bool) ? '1' : '0');
    };

    /**
     * @param {Node} node Node to append a CDATA Section with the string to.
     * @param {string} string String.
     */
    ol.format.XSD.writeCDATASection = function(node, string) {
      node.appendChild(ol.xml.DOCUMENT.createCDATASection(string));
    };

    /**
     * @param {Node} node Node to append a TextNode with the dateTime to.
     * @param {number} dateTime DateTime in seconds.
     */
    ol.format.XSD.writeDateTimeTextNode = function(node, dateTime) {
      var date = new Date(dateTime * 1000);
      var string = date.getUTCFullYear() + '-' +
          ol.string.padNumber(date.getUTCMonth() + 1, 2) + '-' +
          ol.string.padNumber(date.getUTCDate(), 2) + 'T' +
          ol.string.padNumber(date.getUTCHours(), 2) + ':' +
          ol.string.padNumber(date.getUTCMinutes(), 2) + ':' +
          ol.string.padNumber(date.getUTCSeconds(), 2) + 'Z';
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };

    /**
     * @param {Node} node Node to append a TextNode with the decimal to.
     * @param {number} decimal Decimal.
     */
    ol.format.XSD.writeDecimalTextNode = function(node, decimal) {
      var string = decimal.toPrecision();
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };

    /**
     * @param {Node} node Node to append a TextNode with the decimal to.
     * @param {number} nonNegativeInteger Non negative integer.
     */
    ol.format.XSD.writeNonNegativeIntegerTextNode = function(node, nonNegativeInteger) {
      var string = nonNegativeInteger.toString();
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };

    /**
     * @param {Node} node Node to append a TextNode with the string to.
     * @param {string} string String.
     */
    ol.format.XSD.writeStringTextNode = function(node, string) {
      node.appendChild(ol.xml.DOCUMENT.createTextNode(string));
    };